using System.Web.UI.WebControls;
using System.Web.UI;
using System.ComponentModel;
using System;
using Microsoft.Web.Script.Serialization;
using AtlasControlToolkit;

namespace Jeffz.AtlasControlToolkit
{
	[DefaultProperty("Images")]
	public class ImageGalleryProperties : TargetControlPropertiesBase<Panel>
	{
		private ImageCollection _Images = null;

		[DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		[PersistenceMode(PersistenceMode.InnerProperty)]
		public ImageCollection Images
		{
			get
			{
				if (this._Images == null)
				{
					this._Images = new ImageCollection();
				}

				return this._Images;
			}
		}

		[DefaultValue(0)]
		public int Interval
		{
			get
			{
				return this.GetPropertyIntValue("Interval");
			}
			set
			{
				this.SetPropertyIntValue("Interval", value);
			}
		}

		[DefaultValue(0)]
		public int SwitchTime
		{
			get
			{
				return this.GetPropertyIntValue("SwitchTime");
			}
			set
			{
				this.SetPropertyIntValue("SwitchTime", value);
			}
		}

		[IDReferenceProperty]
		[DefaultValue(null)]
		public string WaitingControlID
		{
			get
			{
				return this.GetPropertyStringValue("WaitingControlID");
			}
			set
			{
				this.SetPropertyStringValue("WaitingControlID", value);
			}
		}

		protected override void TrackViewState()
		{
			base.TrackViewState();

			if (this._Images != null)
			{
				((IStateManager)this._Images).TrackViewState();
			}
		}

		protected override object SaveViewState()
		{
			Pair state = new Pair();
			state.First = base.SaveViewState();
			if (this._Images != null)
			{
				state.Second = ((IStateManager)this._Images).SaveViewState();
			}

			return state;
		}

		protected override void LoadViewState(object state)
		{
			Pair statePair = state as Pair;

			if (statePair != null)
			{
				base.LoadViewState(statePair.First);

				if (this._Images != null && statePair.Second != null)
				{
					((IStateManager)this._Images).LoadViewState(statePair.Second);
				}
			}
		}
	}
}
